
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.cheese.init;

import net.minecraftforge.registries.RegistryObject;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.world.BiomeLoadingEvent;

import net.minecraft.world.level.levelgen.placement.PlacedFeature;
import net.minecraft.world.level.levelgen.feature.Feature;
import net.minecraft.world.level.levelgen.GenerationStep;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.core.Holder;

import net.mcreator.cheese.world.features.plants.PepperPlantFeature;
import net.mcreator.cheese.world.features.plants.MilkweedFeature;
import net.mcreator.cheese.world.features.plants.GarlicPlantFeature;
import net.mcreator.cheese.world.features.ores.CheeseOreFeature;
import net.mcreator.cheese.CheeseMod;

import java.util.function.Supplier;
import java.util.Set;
import java.util.List;
import java.util.ArrayList;

@Mod.EventBusSubscriber
public class CheeseModFeatures {
	public static final DeferredRegister<Feature<?>> REGISTRY = DeferredRegister.create(ForgeRegistries.FEATURES, CheeseMod.MODID);
	private static final List<FeatureRegistration> FEATURE_REGISTRATIONS = new ArrayList<>();
	public static final RegistryObject<Feature<?>> CHEESE_ORE = register("cheese_ore", CheeseOreFeature::feature,
			new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES, CheeseOreFeature.GENERATE_BIOMES, CheeseOreFeature::placedFeature));
	public static final RegistryObject<Feature<?>> GARLIC_PLANT = register("garlic_plant", GarlicPlantFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.VEGETAL_DECORATION, GarlicPlantFeature.GENERATE_BIOMES, GarlicPlantFeature::placedFeature));
	public static final RegistryObject<Feature<?>> PEPPER_PLANT = register("pepper_plant", PepperPlantFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.VEGETAL_DECORATION, PepperPlantFeature.GENERATE_BIOMES, PepperPlantFeature::placedFeature));
	public static final RegistryObject<Feature<?>> MILKWEED = register("milkweed", MilkweedFeature::feature,
			new FeatureRegistration(GenerationStep.Decoration.VEGETAL_DECORATION, MilkweedFeature.GENERATE_BIOMES, MilkweedFeature::placedFeature));

	private static RegistryObject<Feature<?>> register(String registryname, Supplier<Feature<?>> feature, FeatureRegistration featureRegistration) {
		FEATURE_REGISTRATIONS.add(featureRegistration);
		return REGISTRY.register(registryname, feature);
	}

	@SubscribeEvent
	public static void addFeaturesToBiomes(BiomeLoadingEvent event) {
		for (FeatureRegistration registration : FEATURE_REGISTRATIONS) {
			if (registration.biomes() == null || registration.biomes().contains(event.getName()))
				event.getGeneration().getFeatures(registration.stage()).add(registration.placedFeature().get());
		}
	}

	private static record FeatureRegistration(GenerationStep.Decoration stage, Set<ResourceLocation> biomes,
			Supplier<Holder<PlacedFeature>> placedFeature) {
	}
}
